Loading...
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0-only
3
4# Copyright (C) 2006 Paul Mackerras, IBM Corporation <paulus@samba.org>
5
6# This script takes a kernel binary and optionally an initrd image
7# and/or a device-tree blob, and creates a bootable zImage for a
8# given platform.
9
10# Options:
11# -o zImage specify output file
12# -p platform specify platform (links in $platform.o)
13# -i initrd specify initrd file
14# -d devtree specify device-tree blob
15# -s tree.dts specify device-tree source file (needs dtc installed)
16# -e esm_blob specify ESM blob for secure images
17# -c cache $kernel.strip.gz (use if present & newer, else make)
18# -C prefix specify command prefix for cross-building tools
19# (strip, objcopy, ld)
20# -D dir specify directory containing data files used by script
21# (default ./arch/powerpc/boot)
22# -W dir specify working directory for temporary files (default .)
23# -z use gzip (legacy)
24# -Z zsuffix compression to use (gz, xz or none)
25
26# Stop execution if any command fails
27set -e
28
29export LC_ALL=C
30
31# Allow for verbose output
32if [ "$V" = 1 ]; then
33 set -x
34 map="-Map wrapper.map"
35fi
36
37# defaults
38kernel=
39ofile=zImage
40platform=of
41initrd=
42dtb=
43dts=
44esm_blob=
45cacheit=
46binary=
47compression=.gz
48uboot_comp=gzip
49pie=
50format=
51notext=
52rodynamic=
53
54# cross-compilation prefix
55CROSS=
56
57# mkimage wrapper script
58MKIMAGE=$srctree/scripts/mkuboot.sh
59
60# directory for object and other files used by this script
61object=arch/powerpc/boot
62objbin=$object
63dtc=scripts/dtc/dtc
64
65# directory for working files
66tmpdir=.
67
68usage() {
69 echo 'Usage: wrapper [-o output] [-p platform] [-i initrd]' >&2
70 echo ' [-d devtree] [-s tree.dts] [-e esm_blob]' >&2
71 echo ' [-c] [-C cross-prefix] [-D datadir] [-W workingdir]' >&2
72 echo ' [-Z (gz|xz|none)] [--no-compression] [vmlinux]' >&2
73 exit 1
74}
75
76run_cmd() {
77 if [ "$V" = 1 ]; then
78 $* 2>&1
79 else
80 local msg
81
82 set +e
83 msg=$($* 2>&1)
84
85 if [ $? -ne "0" ]; then
86 echo $msg
87 exit 1
88 fi
89 set -e
90 fi
91}
92
93while [ "$#" -gt 0 ]; do
94 case "$1" in
95 -o)
96 shift
97 [ "$#" -gt 0 ] || usage
98 ofile="$1"
99 ;;
100 -p)
101 shift
102 [ "$#" -gt 0 ] || usage
103 platform="$1"
104 ;;
105 -i)
106 shift
107 [ "$#" -gt 0 ] || usage
108 initrd="$1"
109 ;;
110 -d)
111 shift
112 [ "$#" -gt 0 ] || usage
113 dtb="$1"
114 ;;
115 -e)
116 shift
117 [ "$#" -gt 0 ] || usage
118 esm_blob="$1"
119 ;;
120 -s)
121 shift
122 [ "$#" -gt 0 ] || usage
123 dts="$1"
124 ;;
125 -c)
126 cacheit=y
127 ;;
128 -C)
129 shift
130 [ "$#" -gt 0 ] || usage
131 CROSS="$1"
132 ;;
133 -D)
134 shift
135 [ "$#" -gt 0 ] || usage
136 object="$1"
137 objbin="$1"
138 ;;
139 -W)
140 shift
141 [ "$#" -gt 0 ] || usage
142 tmpdir="$1"
143 ;;
144 -z)
145 compression=.gz
146 uboot_comp=gzip
147 ;;
148 -Z)
149 shift
150 [ "$#" -gt 0 ] || usage
151 [ "$1" != "gz" -o "$1" != "xz" -o "$1" != "lzma" -o "$1" != "lzo" -o "$1" != "none" ] || usage
152
153 compression=".$1"
154 uboot_comp=$1
155
156 if [ $compression = ".none" ]; then
157 compression=
158 uboot_comp=none
159 fi
160 if [ $uboot_comp = "gz" ]; then
161 uboot_comp=gzip
162 fi
163 ;;
164 --no-gzip)
165 # a "feature" of the wrapper script is that it can be used outside
166 # the kernel tree. So keeping this around for backwards compatibility.
167 compression=
168 uboot_comp=none
169 ;;
170 -?)
171 usage
172 ;;
173 *)
174 [ -z "$kernel" ] || usage
175 kernel="$1"
176 ;;
177 esac
178 shift
179done
180
181
182if [ -n "$dts" ]; then
183 if [ ! -r "$dts" -a -r "$object/dts/$dts" ]; then
184 dts="$object/dts/$dts"
185 fi
186 if [ -z "$dtb" ]; then
187 dtb="$platform.dtb"
188 fi
189 $dtc -O dtb -o "$dtb" -b 0 "$dts"
190fi
191
192if [ -z "$kernel" ]; then
193 kernel=vmlinux
194fi
195
196LC_ALL=C elfformat="`${CROSS}objdump -p "$kernel" | grep 'file format' | awk '{print $4}'`"
197case "$elfformat" in
198 elf64-powerpcle) format=elf64lppc ;;
199 elf64-powerpc) format=elf32ppc ;;
200 elf32-powerpc) format=elf32ppc ;;
201esac
202
203ld_version()
204{
205 # Poached from scripts/ld-version.sh, but we don't want to call that because
206 # this script (wrapper) is distributed separately from the kernel source.
207 # Extract linker version number from stdin and turn into single number.
208 awk '{
209 gsub(".*\\)", "");
210 gsub(".*version ", "");
211 gsub("-.*", "");
212 split($1,a, ".");
213 if( length(a[3]) == "8" )
214 # a[3] is probably a date of format yyyymmdd used for release snapshots. We
215 # can assume it to be zero as it does not signify a new version as such.
216 a[3] = 0;
217 print a[1]*100000000 + a[2]*1000000 + a[3]*10000;
218 exit
219 }'
220}
221
222ld_is_lld()
223{
224 ${CROSS}ld -V 2>&1 | grep -q LLD
225}
226
227# Do not include PT_INTERP segment when linking pie. Non-pie linking
228# just ignores this option.
229LD_VERSION=$(${CROSS}ld --version | ld_version)
230LD_NO_DL_MIN_VERSION=$(echo 2.26 | ld_version)
231if [ "$LD_VERSION" -ge "$LD_NO_DL_MIN_VERSION" ] ; then
232 nodl="--no-dynamic-linker"
233fi
234
235# suppress some warnings in recent ld versions
236nowarn="-z noexecstack"
237if ! ld_is_lld; then
238 if [ "$LD_VERSION" -ge "$(echo 2.39 | ld_version)" ]; then
239 nowarn="$nowarn --no-warn-rwx-segments"
240 fi
241fi
242
243platformo=$object/"$platform".o
244lds=$object/zImage.lds
245ext=strip
246objflags=-S
247tmp=$tmpdir/zImage.$$.o
248ksection=.kernel:vmlinux.strip
249isection=.kernel:initrd
250esection=.kernel:esm_blob
251link_address='0x400000'
252make_space=y
253
254
255if [ -n "$esm_blob" -a "$platform" != "pseries" ]; then
256 echo "ESM blob not support on non-pseries platforms" >&2
257 exit 1
258fi
259
260case "$platform" in
261of)
262 platformo="$object/of.o $object/epapr.o"
263 make_space=n
264 ;;
265pseries)
266 platformo="$object/pseries-head.o $object/of.o $object/epapr.o"
267 link_address='0x4000000'
268 if [ "$format" != "elf32ppc" ]; then
269 link_address=
270 pie=-pie
271 fi
272 make_space=n
273 ;;
274maple)
275 platformo="$object/of.o $object/epapr.o"
276 link_address='0x400000'
277 make_space=n
278 ;;
279pmac|chrp)
280 platformo="$object/of.o $object/epapr.o"
281 make_space=n
282 ;;
283coff)
284 platformo="$object/crt0.o $object/of.o $object/epapr.o"
285 lds=$object/zImage.coff.lds
286 link_address='0x500000'
287 make_space=n
288 pie=
289 ;;
290miboot|uboot*)
291 # miboot and U-boot want just the bare bits, not an ELF binary
292 ext=bin
293 objflags="-O binary"
294 tmp="$ofile"
295 ksection=image
296 isection=initrd
297 ;;
298cuboot*)
299 binary=y
300 compression=
301 case "$platform" in
302 *-mpc866ads|*-mpc885ads|*-adder875*|*-ep88xc)
303 platformo=$object/cuboot-8xx.o
304 ;;
305 *5200*|*-motionpro)
306 platformo=$object/cuboot-52xx.o
307 ;;
308 *-pq2fads|*-ep8248e|*-mpc8272*|*-storcenter)
309 platformo=$object/cuboot-pq2.o
310 ;;
311 *-mpc824*)
312 platformo=$object/cuboot-824x.o
313 ;;
314 *-mpc83*|*-asp834x*)
315 platformo=$object/cuboot-83xx.o
316 ;;
317 *-tqm8541|*-mpc8560*|*-tqm8560|*-tqm8555|*-ksi8560*)
318 platformo=$object/cuboot-85xx-cpm2.o
319 ;;
320 *-mpc85*|*-tqm85*)
321 platformo=$object/cuboot-85xx.o
322 ;;
323 *-amigaone)
324 link_address='0x800000'
325 ;;
326 esac
327 ;;
328ps3)
329 platformo="$object/ps3-head.o $object/ps3-hvcall.o $object/ps3.o"
330 lds=$object/zImage.ps3.lds
331 compression=
332 ext=bin
333 objflags="-O binary --set-section-flags=.bss=contents,alloc,load,data"
334 ksection=.kernel:vmlinux.bin
335 isection=.kernel:initrd
336 link_address=''
337 make_space=n
338 pie=
339 ;;
340ep88xc|ep405|ep8248e)
341 platformo="$object/fixed-head.o $object/$platform.o"
342 binary=y
343 ;;
344adder875-redboot)
345 platformo="$object/fixed-head.o $object/redboot-8xx.o"
346 binary=y
347 ;;
348simpleboot-*)
349 platformo="$object/fixed-head.o $object/simpleboot.o"
350 binary=y
351 ;;
352asp834x-redboot)
353 platformo="$object/fixed-head.o $object/redboot-83xx.o"
354 binary=y
355 ;;
356xpedite52*)
357 link_address='0x1400000'
358 platformo=$object/cuboot-85xx.o
359 ;;
360gamecube|wii)
361 link_address='0x600000'
362 platformo="$object/$platform-head.o $object/$platform.o"
363 ;;
364microwatt)
365 link_address='0x500000'
366 platformo="$object/fixed-head.o $object/$platform.o"
367 binary=y
368 ;;
369treeboot-currituck)
370 link_address='0x1000000'
371 ;;
372treeboot-akebono)
373 link_address='0x1000000'
374 ;;
375treeboot-iss4xx-mpic)
376 platformo="$object/treeboot-iss4xx.o"
377 ;;
378epapr)
379 platformo="$object/pseries-head.o $object/epapr.o $object/epapr-wrapper.o"
380 link_address='0x20000000'
381 pie=-pie
382 notext='-z notext'
383 rodynamic=$(if ${CROSS}ld -V 2>&1 | grep -q LLD ; then echo "-z rodynamic"; fi)
384 ;;
385mvme5100)
386 platformo="$object/fixed-head.o $object/mvme5100.o"
387 binary=y
388 ;;
389mvme7100)
390 platformo="$object/motload-head.o $object/mvme7100.o"
391 link_address='0x4000000'
392 binary=y
393 ;;
394esac
395
396vmz="$tmpdir/`basename \"$kernel\"`.$ext"
397
398# Calculate the vmlinux.strip size
399${CROSS}objcopy $objflags "$kernel" "$vmz.$$"
400strip_size=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" "$vmz.$$")
401
402if [ -z "$cacheit" -o ! -f "$vmz$compression" -o "$vmz$compression" -ot "$kernel" ]; then
403 # recompress the image if we need to
404 case $compression in
405 .xz)
406 xz --check=crc32 -f -6 "$vmz.$$"
407 ;;
408 .gz)
409 gzip -n -f -9 "$vmz.$$"
410 ;;
411 .lzma)
412 xz --format=lzma -f -6 "$vmz.$$"
413 ;;
414 .lzo)
415 lzop -f -9 "$vmz.$$"
416 ;;
417 *)
418 # drop the compression suffix so the stripped vmlinux is used
419 compression=
420 uboot_comp=none
421 ;;
422 esac
423
424 if [ -n "$cacheit" ]; then
425 mv -f "$vmz.$$$compression" "$vmz$compression"
426 else
427 vmz="$vmz.$$"
428 fi
429else
430 rm -f $vmz.$$
431fi
432
433vmz="$vmz$compression"
434
435if [ "$make_space" = "y" ]; then
436 # Round the size to next higher MB limit
437 round_size=$(((strip_size + 0xfffff) & 0xfff00000))
438
439 round_size=0x$(printf "%x" $round_size)
440 link_addr=$(printf "%d" $link_address)
441
442 if [ $link_addr -lt $strip_size ]; then
443 echo "INFO: Uncompressed kernel (size 0x$(printf "%x\n" $strip_size))" \
444 "overlaps the address of the wrapper($link_address)"
445 echo "INFO: Fixing the link_address of wrapper to ($round_size)"
446 link_address=$round_size
447 fi
448fi
449
450# Extract kernel version information, some platforms want to include
451# it in the image header
452version=`${CROSS}strings "$kernel" | grep '^Linux version [-0-9.]' | \
453 head -n1 | cut -d' ' -f3`
454if [ -n "$version" ]; then
455 uboot_version="-n Linux-$version"
456fi
457
458# physical offset of kernel image
459membase=`${CROSS}objdump -p "$kernel" | grep -m 1 LOAD | awk '{print $7}'`
460
461case "$platform" in
462uboot)
463 rm -f "$ofile"
464 ${MKIMAGE} -A ppc -O linux -T kernel -C $uboot_comp -a $membase -e $membase \
465 $uboot_version -d "$vmz" "$ofile"
466 if [ -z "$cacheit" ]; then
467 rm -f "$vmz"
468 fi
469 exit 0
470 ;;
471uboot-obs600)
472 rm -f "$ofile"
473 # obs600 wants a multi image with an initrd, so we need to put a fake
474 # one in even when building a "normal" image.
475 if [ -n "$initrd" ]; then
476 real_rd="$initrd"
477 else
478 real_rd=`mktemp`
479 echo "\0" >>"$real_rd"
480 fi
481 ${MKIMAGE} -A ppc -O linux -T multi -C gzip -a $membase -e $membase \
482 $uboot_version -d "$vmz":"$real_rd":"$dtb" "$ofile"
483 if [ -z "$initrd" ]; then
484 rm -f "$real_rd"
485 fi
486 if [ -z "$cacheit" ]; then
487 rm -f "$vmz"
488 fi
489 exit 0
490 ;;
491esac
492
493addsec() {
494 ${CROSS}objcopy $4 $1 \
495 --add-section=$3="$2" \
496 --set-section-flags=$3=contents,alloc,load,readonly,data
497}
498
499addsec $tmp "$vmz" $ksection $object/empty.o
500if [ -z "$cacheit" ]; then
501 rm -f "$vmz"
502fi
503
504if [ -n "$initrd" ]; then
505 addsec $tmp "$initrd" $isection
506fi
507
508if [ -n "$dtb" ]; then
509 addsec $tmp "$dtb" .kernel:dtb
510 if [ -n "$dts" ]; then
511 rm $dtb
512 fi
513fi
514
515if [ -n "$esm_blob" ]; then
516 addsec $tmp "$esm_blob" $esection
517fi
518
519if [ "$platform" != "miboot" ]; then
520 if [ -n "$link_address" ] ; then
521 text_start="-Ttext $link_address"
522 fi
523#link everything
524 ${CROSS}ld -m $format -T $lds $text_start $pie $nodl $nowarn $rodynamic $notext -o "$ofile" $map \
525 $platformo $tmp $object/wrapper.a
526 rm $tmp
527fi
528
529# Some platforms need the zImage's entry point and base address
530base=0x`${CROSS}nm "$ofile" | grep ' _start$' | cut -d' ' -f1`
531entry=`${CROSS}objdump -f "$ofile" | grep '^start address ' | cut -d' ' -f3`
532
533if [ -n "$binary" ]; then
534 mv "$ofile" "$ofile".elf
535 ${CROSS}objcopy -O binary "$ofile".elf "$ofile"
536fi
537
538# post-processing needed for some platforms
539case "$platform" in
540pseries|chrp|maple)
541 $objbin/addnote "$ofile"
542 ;;
543coff)
544 ${CROSS}objcopy -O aixcoff-rs6000 --set-start "$entry" "$ofile"
545 $objbin/hack-coff "$ofile"
546 ;;
547cuboot*)
548 gzip -n -f -9 "$ofile"
549 ${MKIMAGE} -A ppc -O linux -T kernel -C gzip -a "$base" -e "$entry" \
550 $uboot_version -d "$ofile".gz "$ofile"
551 ;;
552treeboot*)
553 mv "$ofile" "$ofile.elf"
554 $objbin/mktree "$ofile.elf" "$ofile" "$base" "$entry"
555 if [ -z "$cacheit" ]; then
556 rm -f "$ofile.elf"
557 fi
558 exit 0
559 ;;
560ps3)
561 # The ps3's loader supports loading a gzipped binary image from flash
562 # rom to ram addr zero. The loader then enters the system reset
563 # vector at addr 0x100. A bootwrapper overlay is used to arrange for
564 # a binary image of the kernel to be at addr zero, and yet have a
565 # suitable bootwrapper entry at 0x100. To construct the final rom
566 # image 512 bytes from offset 0x100 is copied to the bootwrapper
567 # place holder at symbol __system_reset_kernel. The 512 bytes of the
568 # bootwrapper entry code at symbol __system_reset_overlay is then
569 # copied to offset 0x100. At runtime the bootwrapper program copies
570 # the data at __system_reset_kernel back to addr 0x100.
571
572 system_reset_overlay=0x`${CROSS}nm "$ofile" \
573 | grep ' __system_reset_overlay$' \
574 | cut -d' ' -f1`
575 system_reset_overlay=`printf "%d" $system_reset_overlay`
576 system_reset_kernel=0x`${CROSS}nm "$ofile" \
577 | grep ' __system_reset_kernel$' \
578 | cut -d' ' -f1`
579 system_reset_kernel=`printf "%d" $system_reset_kernel`
580 overlay_dest="256"
581 overlay_size="512"
582
583 ${CROSS}objcopy -O binary "$ofile" "$ofile.bin"
584
585 run_cmd dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
586 skip=$overlay_dest seek=$system_reset_kernel \
587 count=$overlay_size bs=1
588
589 run_cmd dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
590 skip=$system_reset_overlay seek=$overlay_dest \
591 count=$overlay_size bs=1
592
593 odir="$(dirname "$ofile.bin")"
594
595 # The ps3's flash loader has a size limit of 16 MiB for the uncompressed
596 # image. If a compressed image that exceeded this limit is written to
597 # flash the loader will decompress that image until the 16 MiB limit is
598 # reached, then enter the system reset vector of the partially decompressed
599 # image. No warning is issued.
600 rm -f "$odir"/{otheros,otheros-too-big}.bld
601 size=$(${CROSS}nm --no-sort --radix=d "$ofile" | grep -E ' _end$' | cut -d' ' -f1)
602 bld="otheros.bld"
603 if [ $size -gt $((0x1000000)) ]; then
604 bld="otheros-too-big.bld"
605 fi
606 gzip -n --force -9 --stdout "$ofile.bin" > "$odir/$bld"
607 ;;
608esac
1#!/bin/sh
2
3# Copyright (C) 2006 Paul Mackerras, IBM Corporation <paulus@samba.org>
4# This program may be used under the terms of version 2 of the GNU
5# General Public License.
6
7# This script takes a kernel binary and optionally an initrd image
8# and/or a device-tree blob, and creates a bootable zImage for a
9# given platform.
10
11# Options:
12# -o zImage specify output file
13# -p platform specify platform (links in $platform.o)
14# -i initrd specify initrd file
15# -d devtree specify device-tree blob
16# -s tree.dts specify device-tree source file (needs dtc installed)
17# -c cache $kernel.strip.gz (use if present & newer, else make)
18# -C prefix specify command prefix for cross-building tools
19# (strip, objcopy, ld)
20# -D dir specify directory containing data files used by script
21# (default ./arch/powerpc/boot)
22# -W dir specify working directory for temporary files (default .)
23
24# Stop execution if any command fails
25set -e
26
27# Allow for verbose output
28if [ "$V" = 1 ]; then
29 set -x
30fi
31
32# defaults
33kernel=
34ofile=zImage
35platform=of
36initrd=
37dtb=
38dts=
39cacheit=
40binary=
41gzip=.gz
42pie=
43
44# cross-compilation prefix
45CROSS=
46
47# mkimage wrapper script
48MKIMAGE=$srctree/scripts/mkuboot.sh
49
50# directory for object and other files used by this script
51object=arch/powerpc/boot
52objbin=$object
53dtc=scripts/dtc/dtc
54
55# directory for working files
56tmpdir=.
57
58usage() {
59 echo 'Usage: wrapper [-o output] [-p platform] [-i initrd]' >&2
60 echo ' [-d devtree] [-s tree.dts] [-c] [-C cross-prefix]' >&2
61 echo ' [-D datadir] [-W workingdir] [--no-gzip] [vmlinux]' >&2
62 exit 1
63}
64
65while [ "$#" -gt 0 ]; do
66 case "$1" in
67 -o)
68 shift
69 [ "$#" -gt 0 ] || usage
70 ofile="$1"
71 ;;
72 -p)
73 shift
74 [ "$#" -gt 0 ] || usage
75 platform="$1"
76 ;;
77 -i)
78 shift
79 [ "$#" -gt 0 ] || usage
80 initrd="$1"
81 ;;
82 -d)
83 shift
84 [ "$#" -gt 0 ] || usage
85 dtb="$1"
86 ;;
87 -s)
88 shift
89 [ "$#" -gt 0 ] || usage
90 dts="$1"
91 ;;
92 -c)
93 cacheit=y
94 ;;
95 -C)
96 shift
97 [ "$#" -gt 0 ] || usage
98 CROSS="$1"
99 ;;
100 -D)
101 shift
102 [ "$#" -gt 0 ] || usage
103 object="$1"
104 objbin="$1"
105 ;;
106 -W)
107 shift
108 [ "$#" -gt 0 ] || usage
109 tmpdir="$1"
110 ;;
111 --no-gzip)
112 gzip=
113 ;;
114 -?)
115 usage
116 ;;
117 *)
118 [ -z "$kernel" ] || usage
119 kernel="$1"
120 ;;
121 esac
122 shift
123done
124
125if [ -n "$dts" ]; then
126 if [ ! -r "$dts" -a -r "$object/dts/$dts" ]; then
127 dts="$object/dts/$dts"
128 fi
129 if [ -z "$dtb" ]; then
130 dtb="$platform.dtb"
131 fi
132 $dtc -O dtb -o "$dtb" -b 0 "$dts"
133fi
134
135if [ -z "$kernel" ]; then
136 kernel=vmlinux
137fi
138
139platformo=$object/"$platform".o
140lds=$object/zImage.lds
141ext=strip
142objflags=-S
143tmp=$tmpdir/zImage.$$.o
144ksection=.kernel:vmlinux.strip
145isection=.kernel:initrd
146link_address='0x400000'
147
148case "$platform" in
149pseries)
150 platformo=$object/of.o
151 link_address='0x4000000'
152 ;;
153maple)
154 platformo=$object/of.o
155 link_address='0x400000'
156 ;;
157pmac|chrp)
158 platformo=$object/of.o
159 ;;
160coff)
161 platformo="$object/crt0.o $object/of.o"
162 lds=$object/zImage.coff.lds
163 link_address='0x500000'
164 pie=
165 ;;
166miboot|uboot)
167 # miboot and U-boot want just the bare bits, not an ELF binary
168 ext=bin
169 objflags="-O binary"
170 tmp="$ofile"
171 ksection=image
172 isection=initrd
173 ;;
174cuboot*)
175 binary=y
176 gzip=
177 case "$platform" in
178 *-mpc866ads|*-mpc885ads|*-adder875*|*-ep88xc)
179 platformo=$object/cuboot-8xx.o
180 ;;
181 *5200*|*-motionpro)
182 platformo=$object/cuboot-52xx.o
183 ;;
184 *-pq2fads|*-ep8248e|*-mpc8272*|*-storcenter)
185 platformo=$object/cuboot-pq2.o
186 ;;
187 *-mpc824*)
188 platformo=$object/cuboot-824x.o
189 ;;
190 *-mpc83*|*-asp834x*)
191 platformo=$object/cuboot-83xx.o
192 ;;
193 *-tqm8541|*-mpc8560*|*-tqm8560|*-tqm8555|*-ksi8560*)
194 platformo=$object/cuboot-85xx-cpm2.o
195 ;;
196 *-mpc85*|*-tqm85*|*-sbc85*)
197 platformo=$object/cuboot-85xx.o
198 ;;
199 *-amigaone)
200 link_address='0x800000'
201 ;;
202 esac
203 ;;
204ps3)
205 platformo="$object/ps3-head.o $object/ps3-hvcall.o $object/ps3.o"
206 lds=$object/zImage.ps3.lds
207 gzip=
208 ext=bin
209 objflags="-O binary --set-section-flags=.bss=contents,alloc,load,data"
210 ksection=.kernel:vmlinux.bin
211 isection=.kernel:initrd
212 link_address=''
213 pie=
214 ;;
215ep88xc|ep405|ep8248e)
216 platformo="$object/fixed-head.o $object/$platform.o"
217 binary=y
218 ;;
219adder875-redboot)
220 platformo="$object/fixed-head.o $object/redboot-8xx.o"
221 binary=y
222 ;;
223simpleboot-virtex405-*)
224 platformo="$object/virtex405-head.o $object/simpleboot.o $object/virtex.o"
225 binary=y
226 ;;
227simpleboot-virtex440-*)
228 platformo="$object/fixed-head.o $object/simpleboot.o $object/virtex.o"
229 binary=y
230 ;;
231simpleboot-*)
232 platformo="$object/fixed-head.o $object/simpleboot.o"
233 binary=y
234 ;;
235asp834x-redboot)
236 platformo="$object/fixed-head.o $object/redboot-83xx.o"
237 binary=y
238 ;;
239xpedite52*)
240 link_address='0x1400000'
241 platformo=$object/cuboot-85xx.o
242 ;;
243gamecube|wii)
244 link_address='0x600000'
245 platformo="$object/$platform-head.o $object/$platform.o"
246 ;;
247treeboot-iss4xx-mpic)
248 platformo="$object/treeboot-iss4xx.o"
249 ;;
250epapr)
251 link_address='0x20000000'
252 pie=-pie
253 ;;
254esac
255
256vmz="$tmpdir/`basename \"$kernel\"`.$ext"
257if [ -z "$cacheit" -o ! -f "$vmz$gzip" -o "$vmz$gzip" -ot "$kernel" ]; then
258 ${CROSS}objcopy $objflags "$kernel" "$vmz.$$"
259
260 if [ -n "$gzip" ]; then
261 gzip -n -f -9 "$vmz.$$"
262 fi
263
264 if [ -n "$cacheit" ]; then
265 mv -f "$vmz.$$$gzip" "$vmz$gzip"
266 else
267 vmz="$vmz.$$"
268 fi
269fi
270
271vmz="$vmz$gzip"
272
273# Extract kernel version information, some platforms want to include
274# it in the image header
275version=`${CROSS}strings "$kernel" | grep '^Linux version [-0-9.]' | \
276 cut -d' ' -f3`
277if [ -n "$version" ]; then
278 uboot_version="-n Linux-$version"
279fi
280
281# physical offset of kernel image
282membase=`${CROSS}objdump -p "$kernel" | grep -m 1 LOAD | awk '{print $7}'`
283
284case "$platform" in
285uboot)
286 rm -f "$ofile"
287 ${MKIMAGE} -A ppc -O linux -T kernel -C gzip -a $membase -e $membase \
288 $uboot_version -d "$vmz" "$ofile"
289 if [ -z "$cacheit" ]; then
290 rm -f "$vmz"
291 fi
292 exit 0
293 ;;
294esac
295
296addsec() {
297 ${CROSS}objcopy $4 $1 \
298 --add-section=$3="$2" \
299 --set-section-flags=$3=contents,alloc,load,readonly,data
300}
301
302addsec $tmp "$vmz" $ksection $object/empty.o
303if [ -z "$cacheit" ]; then
304 rm -f "$vmz"
305fi
306
307if [ -n "$initrd" ]; then
308 addsec $tmp "$initrd" $isection
309fi
310
311if [ -n "$dtb" ]; then
312 addsec $tmp "$dtb" .kernel:dtb
313 if [ -n "$dts" ]; then
314 rm $dtb
315 fi
316fi
317
318if [ "$platform" != "miboot" ]; then
319 if [ -n "$link_address" ] ; then
320 text_start="-Ttext $link_address"
321 fi
322 ${CROSS}ld -m elf32ppc -T $lds $text_start $pie -o "$ofile" \
323 $platformo $tmp $object/wrapper.a
324 rm $tmp
325fi
326
327# Some platforms need the zImage's entry point and base address
328base=0x`${CROSS}nm "$ofile" | grep ' _start$' | cut -d' ' -f1`
329entry=`${CROSS}objdump -f "$ofile" | grep '^start address ' | cut -d' ' -f3`
330
331if [ -n "$binary" ]; then
332 mv "$ofile" "$ofile".elf
333 ${CROSS}objcopy -O binary "$ofile".elf "$ofile"
334fi
335
336# post-processing needed for some platforms
337case "$platform" in
338pseries|chrp|maple)
339 $objbin/addnote "$ofile"
340 ;;
341coff)
342 ${CROSS}objcopy -O aixcoff-rs6000 --set-start "$entry" "$ofile"
343 $objbin/hack-coff "$ofile"
344 ;;
345cuboot*)
346 gzip -n -f -9 "$ofile"
347 ${MKIMAGE} -A ppc -O linux -T kernel -C gzip -a "$base" -e "$entry" \
348 $uboot_version -d "$ofile".gz "$ofile"
349 ;;
350treeboot*)
351 mv "$ofile" "$ofile.elf"
352 $objbin/mktree "$ofile.elf" "$ofile" "$base" "$entry"
353 if [ -z "$cacheit" ]; then
354 rm -f "$ofile.elf"
355 fi
356 exit 0
357 ;;
358ps3)
359 # The ps3's loader supports loading a gzipped binary image from flash
360 # rom to ram addr zero. The loader then enters the system reset
361 # vector at addr 0x100. A bootwrapper overlay is used to arrange for
362 # a binary image of the kernel to be at addr zero, and yet have a
363 # suitable bootwrapper entry at 0x100. To construct the final rom
364 # image 512 bytes from offset 0x100 is copied to the bootwrapper
365 # place holder at symbol __system_reset_kernel. The 512 bytes of the
366 # bootwrapper entry code at symbol __system_reset_overlay is then
367 # copied to offset 0x100. At runtime the bootwrapper program copies
368 # the data at __system_reset_kernel back to addr 0x100.
369
370 system_reset_overlay=0x`${CROSS}nm "$ofile" \
371 | grep ' __system_reset_overlay$' \
372 | cut -d' ' -f1`
373 system_reset_overlay=`printf "%d" $system_reset_overlay`
374 system_reset_kernel=0x`${CROSS}nm "$ofile" \
375 | grep ' __system_reset_kernel$' \
376 | cut -d' ' -f1`
377 system_reset_kernel=`printf "%d" $system_reset_kernel`
378 overlay_dest="256"
379 overlay_size="512"
380
381 ${CROSS}objcopy -O binary "$ofile" "$ofile.bin"
382
383 dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
384 skip=$overlay_dest seek=$system_reset_kernel \
385 count=$overlay_size bs=1
386
387 dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
388 skip=$system_reset_overlay seek=$overlay_dest \
389 count=$overlay_size bs=1
390
391 odir="$(dirname "$ofile.bin")"
392 rm -f "$odir/otheros.bld"
393 gzip -n --force -9 --stdout "$ofile.bin" > "$odir/otheros.bld"
394 ;;
395esac